module RmPlugin
  #
  # Plugins for the removal of accounts.
  #

  def delete_domain(domain)
    # Delete the given domain.
    raise NotImplementedError
  end

  def delete_account(account)
    # Delete the given account.
    raise NotImplementedError
  end

  def get_leftover_domains(db_domains)
    # Given a list of domains, determine which domains belonging to
    # this plugin are not contained in the given list.
    raise NotImplementedError
  end

  def get_leftover_accounts(db_accounts)
    # Given a list of accounts, determine which accounts belonging to
    # this plugin are not contained in the given list.
    raise NotImplementedError
  end
end
